# PHTTPServer Class Reference

A TCP/IP socket for the HyperText Transfer Protocol version 1.0. More...

`#include <http.h>`

Inheritance diagram for PHTTPServer:

List of all members.

## Public Member Functions

| PHTTPServer ()
| Create a TCP/IP HTTP protocol socket channel.
| PHTTPServer (const PHTTPSpace &urlSpace)
virtual PString | GetServerName () const
| Get the name of the server.
PHTTPSpace & | GetURLSpace ()
| Get the name space being used by the HTTP server socket.
void | SetURLSpace (const PHTTPSpace &space)
| Use a new URL name space for this HTTP socket.
virtual PBoolean | ProcessCommand ()
| Process commands, dispatching to the appropriate virtual function.
virtual PBoolean | OnGET (const PURL &url, const PMIMEInfo &info, const PHTTPConnectionInfo &conInfo)
| Handle a GET command from a client.
virtual PBoolean | OnHEAD (const PURL &url, const PMIMEInfo &info, const PHTTPConnectionInfo &conInfo)
| Handle a HEAD command from a client.
virtual PBoolean | OnPOST (const PURL &url, const PMIMEInfo &info, const PStringToString &data, const PHTTPConnectionInfo &conInfo)
| Handle a POST command from a client.
virtual PBoolean | OnProxy (const PHTTPConnectionInfo &conInfo)
| Handle a proxy command request from a client.
virtual PString | ReadEntityBody ()
| Read the entity body associated with a HTTP request, and close the socket if not a persistent connection.
virtual PBoolean | OnUnknown (const PCaselessString &command, const PHTTPConnectionInfo &connectInfo)
| Handle an unknown command.
PBoolean | StartResponse (StatusCode code, PMIMEInfo &headers, long bodySize)
| Write a command reply back to the client, and construct some of the outgoing MIME fields.
virtual PBoolean | OnError (StatusCode code, const PCaselessString &extra, const PHTTPConnectionInfo &connectInfo)
| Write an error response for the specified code.
void | SetDefaultMIMEInfo (PMIMEInfo &info, const PHTTPConnectionInfo &connectInfo)
| Set the default mime info.
PHTTPConnectionInfo & | GetConnectionInfo ()
| Get the connection info for this connection.

## Protected Member Functions

void | Construct ()

## Protected Attributes

PHTTPSpace | urlSpace
PHTTPConnectionInfo | connectInfo
unsigned | transactionCount
PTimeInterval | nextTimeout

## Detailed Description

A TCP/IP socket for the HyperText Transfer Protocol version 1.0.

The server socket thread would continuously call the ProcessCommand() function until it returns false. This will then call the appropriate virtual function on parsing the HTTP protocol.

        PTCPSocket socket(80);
        if (!socket.Listen())
          return;

        PHTTPSpace httpNameSpace;
        httpNameSpace.AddResource(new PHTTPDirectory("data", "data"))

        PHTTServer httpServer(httpNameSpace);
        if (!httpServer.Open(socket))
          return;

        while (httpServer.ProcessCommand())
          ;

## Constructor & Destructor Documentation

PHTTPServer::PHTTPServer | ( |  | ) |

Create a TCP/IP HTTP protocol socket channel.

The form with the single `port` parameter creates an unopened socket, the form with the `address` parameter makes a connection to a remote system, opening the socket. The form with the `socket` parameter opens the socket to an incoming call from a "listening" socket.

PHTTPServer::PHTTPServer | ( | const PHTTPSpace & | urlSpace | ) |

Parameters:

  urlSpace | Name space to use for URLs received.

## Member Function Documentation

void PHTTPServer::Construct | ( |  | ) | `[protected]`

Reimplemented from PChannel.

PHTTPConnectionInfo& PHTTPServer::GetConnectionInfo | ( |  | ) | `[inline]`

Get the connection info for this connection.

virtual PString PHTTPServer::GetServerName | ( |  | ) | const`[virtual]`

Get the name of the server.

Returns:
  String name of the server.

PHTTPSpace& PHTTPServer::GetURLSpace | ( |  | ) | `[inline]`

Get the name space being used by the HTTP server socket.

Returns:
  URL name space tree.

virtual PBoolean PHTTPServer::OnError | ( | StatusCode | code,
|  | const PCaselessString & | extra,
|  | const PHTTPConnectionInfo & | connectInfo |
| ) |  |  | `[virtual]`

Write an error response for the specified code.

Depending on the `code` parameter this function will also send a HTML version of the status code for display on the remote client viewer.

Returns:
  true if the connection may persist, false if the connection must close

Parameters:

  code | Status code for the error response.
  extra | Extra information included in the response.
  connectInfo | HTTP connection information

virtual PBoolean PHTTPServer::OnGET | ( | const PURL & | url,
|  | const PMIMEInfo & | info,
|  | const PHTTPConnectionInfo & | conInfo |
| ) |  |  | `[virtual]`

Handle a GET command from a client.

The default implementation looks up the URL in the name space declared by the `PHTTPSpace` class tree and despatches to the `PHTTPResource` object contained therein.

Returns:
  true if the connection may persist, false if the connection must close If there is no ContentLength field in the response, this value must be false for correct operation.

Parameters:

  url | Universal Resource Locator for document.
  info | Extra MIME information in command.
  conInfo | HTTP connection information

virtual PBoolean PHTTPServer::OnHEAD | ( | const PURL & | url,
|  | const PMIMEInfo & | info,
|  | const PHTTPConnectionInfo & | conInfo |
| ) |  |  | `[virtual]`

Handle a HEAD command from a client.

The default implemetation looks up the URL in the name space declared by the `PHTTPSpace` class tree and despatches to the `PHTTPResource` object contained therein.

Returns:
  true if the connection may persist, false if the connection must close If there is no ContentLength field in the response, this value must be false for correct operation.

Parameters:

  url | Universal Resource Locator for document.
  info | Extra MIME information in command.
  conInfo | HTTP connection information

virtual PBoolean PHTTPServer::OnPOST | ( | const PURL & | url,
|  | const PMIMEInfo & | info,
|  | const PStringToString & | data,
|  | const PHTTPConnectionInfo & | conInfo |
| ) |  |  | `[virtual]`

Handle a POST command from a client.

The default implementation looks up the URL in the name space declared by the `PHTTPSpace` class tree and despatches to the `PHTTPResource` object contained therein.

Returns:
  true if the connection may persist, false if the connection must close If there is no ContentLength field in the response, this value must be false for correct operation.

Parameters:

  url | Universal Resource Locator for document.
  info | Extra MIME information in command.
  data | Variables provided in the POST data.
  conInfo | HTTP connection information

virtual PBoolean PHTTPServer::OnProxy | ( | const PHTTPConnectionInfo & | conInfo | ) | `[virtual]`

Handle a proxy command request from a client.

This will only get called if the request was not for this particular server. If it was a proxy request for this server (host and port number) then the appropriate `OnGET()`, `OnHEAD()` or `OnPOST()` command is called.

The default implementation returns OnError(BadGateway).

Returns:
  true if the connection may persist, false if the connection must close If there is no ContentLength field in the response, this value must be false for correct operation.

Parameters:

  conInfo | HTTP connection information

virtual PBoolean PHTTPServer::OnUnknown | ( | const PCaselessString & | command,
|  | const PHTTPConnectionInfo & | connectInfo |
| ) |  |  | `[virtual]`

Handle an unknown command.

Returns:
  true if the connection may persist, false if the connection must close

Parameters:

  command | Complete command line received.
  connectInfo | HTTP connection information

virtual PBoolean PHTTPServer::ProcessCommand | ( |  | ) | `[virtual]`

Process commands, dispatching to the appropriate virtual function.

This is used when the socket is acting as a server.

Returns:
  true if the request specified persistent mode and the request version allows it, false if the socket closed, timed out, the protocol does not allow persistent mode, or the client did not request it timed out

virtual PString PHTTPServer::ReadEntityBody | ( |  | ) | `[virtual]`

Read the entity body associated with a HTTP request, and close the socket if not a persistent connection.

Returns:
  The entity body of the command

void PHTTPServer::SetDefaultMIMEInfo | ( | PMIMEInfo & | info,
|  | const PHTTPConnectionInfo & | connectInfo |
| ) |  |  |

Set the default mime info.

Parameters:

  info | Extra MIME information in command.
  connectInfo | Connection information

void PHTTPServer::SetURLSpace | ( | const PHTTPSpace & | space | ) |

Use a new URL name space for this HTTP socket.

Parameters:

  space | New URL name space to use.

PBoolean PHTTPServer::StartResponse | ( | StatusCode | code,
|  | PMIMEInfo & | headers,
|  | long | bodySize |
| ) |  |  |

Write a command reply back to the client, and construct some of the outgoing MIME fields.

The MIME fields are not sent.

The `bodySize` parameter determines the size of the entity body associated with the response. If `bodySize` is >= 0, then a ContentLength field will be added to the outgoing MIME headers if one does not already exist.

If `bodySize` is < 0, then it is assumed that the size of the entity body is unknown, or has already been added, and no ContentLength field will be constructed.

If the version of the request is less than 1.0, then this function does nothing.

Returns:
  true if requires v1.1 chunked transfer encoding.

Parameters:

  code | Status code for the response.
  headers | MIME variables included in response.
  bodySize | Size of the rest of the response.

## Member Data Documentation

PHTTPConnectionInfo PHTTPServer::connectInfo `[protected]`

PTimeInterval PHTTPServer::nextTimeout `[protected]`

unsigned PHTTPServer::transactionCount `[protected]`

PHTTPSpace PHTTPServer::urlSpace `[protected]`

The documentation for this class was generated from the following file:

- http.h